/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Preference
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#include "n80_form.h"
#include "n80_directx.h"
#include "../z80/z80_thread.h"
#include "../res/resource.h"
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern z80_thread	*th;
extern n80_directx	*dx;
/**--------------------------------------------------------------------------
 **		W[ϐ
 **------------------------------------------------------------------------*/
static HWND			hEDTHlp;
static const TCHAR	buff[] =
		TEXT("==========================================\r\n")
		TEXT(" \"N80\"̃L[ɂ\r\n")
		TEXT("==========================================\r\n")
		TEXT("[F6] ................ N80`ُ̧o\r\n")
		TEXT("[F7] ................ @\ݒ\r\n")
		TEXT("[F8] ................ TEh ON/OFF\r\n")
		TEXT("[F9] ................ N80/CMTt@CI\r\n")
		TEXT("[F11] ............... PCG-8100 ON/OFF\r\n")
		TEXT("[F12] ............... Zbg{^\r\n")
		TEXT("\r\n")
		TEXT("[SHIFT]+[F9] ........ CMŢٕۑw(CSAVE/W)\r\n")
		TEXT("[SHIFT]+[F12] ....... Sʐ؂ւ ON/OFF\r\n")
		TEXT("\r\n")
		TEXT("==========================================\r\n")
		TEXT(" \"N80\"̃L[oChɂ\r\n")
		TEXT("==========================================\r\n")
		TEXT("[GRPH] .............. [ϊ]\r\n")
		TEXT("[Ji] .............. [ϊ]\r\n")
		TEXT("[STOP] .............. [BS]\r\n")
		TEXT("\r\n")
		TEXT("==========================================\r\n")
		TEXT(" \"N80\"̋@\ݒɂ\r\n")
		TEXT("==========================================\r\n")
		TEXT("[DMA load] .......... VRAMDMA]xw(100)\r\n")
		TEXT("[DMA gain] .......... LŎw̒ľZP(20)\r\n")
		TEXT("[Volue] ............. DirectSoundʰ޳Volume(db)\r\n")
		TEXT("[Amplitude] ......... DirectSoundĳVolume\r\n")
		TEXT("\r\n")
		TEXT("[Text diff-draw]..... ύXŝݕ`ւ\r\n")
		TEXT("[Interlace like]..... ڰ\r\n")
		TEXT("[TenKeyLess] ........ Key2468Ă(ݷ̖KBp)\r\n")
		TEXT("[NoWait] ............ M1WaitROMر̳Ă\r\n")
		TEXT("[720x480] ........... Sʎ640x480gȂꍇɎw\r\n")
		TEXT("");
/**--------------------------------------------------------------------------
 **		_CAO֐
 **------------------------------------------------------------------------*/
static BOOL CALLBACK
MyDlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{

	switch (msg) {
	case WM_INITDIALOG:
		hEDTHlp  = ::GetDlgItem(hWnd, IDC_EDIT1);

		::SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM) TEXT("N80ɂ"));
		::SendMessage(hEDTHlp,  WM_SETTEXT, 0, (LPARAM) buff);
		::SendMessage(hEDTHlp,  EM_SETREADONLY, 1, 0);
		break;

	case WM_COMMAND:
		switch (LOWORD(wp)) {
		case IDOK:
		case IDCANCEL:
			::EndDialog(hWnd, 1);
			return TRUE;
		}
	}
	return FALSE;
}
/**--------------------------------------------------------------------------
 **		About Dialog
 **------------------------------------------------------------------------*/
void
n80_form::about()
{
	if (th->sync())
	{
		dx->stop();
		ShowCursorFullScreen();
		::SetFocus(mWnd);
		::InvalidateRect(mWnd, NULL, FALSE);
		DWORD result = ::DialogBox(mInstance, MAKEINTRESOURCE(IDD_DIALOG2), mWnd, MyDlgProc);
		HideCursorFullScreen();
		::SetFocus(mWnd);
		n80device.attr.invalid();
		th->desync();
		dx->play();
	}
}
