;==============================================================================
;
;	PC-8001 Device Emulator Ver 1.10
;	Copyright (C)1993-97 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.2
;	last modified  Jun,16,1997.
;
__BLT4020_ASM__	equ	1
;==============================================================================
include		n80.mac
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	_blt4020 (eax=line)
;------------------------------------------------------------------------------
;	ebx = eval_table, text_table ptr	# set before invoke this
;	edi = video ram address
;	esi = pattern address
;	ebp = original font address
;------------------------------------------------------------------------------
		public	_blt4020
_blt4020	proc	near
		cmp	eax,20
		jb	@f
		ret
@@:		mov	edi,_n80win32._vram_addr
;		add	edi,_vtbl_vram20[eax*4]
		add	edi,_n80win32._vtbl_vram20[eax*4]
		mov	ebp,offset FLAT:_n80device._fnt
		mov	ecx,40
_blt4020_0:	push	ebp
		push	ebx
		push	ecx
;;;;;;;;;;;;;;;;
		mov	al,[ebx]	; PAC
		mov	ah,[ebx+80]	; 8bit-ascii code

		mov	cl,al		; color -> pattern_table
		and	cl,07h
		movzx	esi,cl
		mov	esi,_n80win32._vtbl_patt40[esi*4]

		movzx	edx,ah		; ascii -> font address
		test	al,10h
		jz	_blt4020_1
		add	edx,256
		jmp	@f
_blt4020_1:	cmp	byte ptr _n80device._pcg_mode,0
		je	@f
		add	edx,512
@@:		shl	edx,3
		add	ebp,edx

		test	al,20h		; branch by graf bit
		jnz	@f
		call	_blt4020n
		jmp	_blt4020_2
@@:		call	_blt4020r
_blt4020_2:	nop
;;;;;;;;;;;;;;;;
		pop	ecx
		pop	ebx
		pop	ebp
		add	ebx,2
		loop	_blt4020_0
		ret
_blt4020	endp
;------------------------------------------------------------------------------
;		void	_blt4020n
;------------------------------------------------------------------------------
_blt4020n	proc	near
		push	edi
;		mov	edx,640*2
		mov	edx,_n80win32._vram_lpitch

		xor	eax,eax
		mov	ecx,eax
		mov	[edi],eax
		mov	[edi+4],ecx
		mov	[edi+edx],eax
		mov	[edi+edx+4],ecx
		mov	[edi+8],eax
		mov	[edi+12],ecx
		mov	[edi+edx+8],eax
		mov	[edi+edx+12],ecx
		add	edi,edx
		add	edi,edx

		_trn40
		_trn40
		_trn40
		_trn40
		_trn40
		_trn40
		_trn40
		_trn40

		xor	eax,eax
		mov	ecx,eax
		mov	[edi],eax
		mov	[edi+4],ecx
		mov	[edi+edx],eax
		mov	[edi+edx+4],ecx
		mov	[edi+8],eax
		mov	[edi+12],ecx
		mov	[edi+edx+8],eax
		mov	[edi+edx+12],ecx
		add	edi,edx

;		sub	edi,640*20-16
		pop	edi
		add	edi,16
		ret
_blt4020n	endp
;------------------------------------------------------------------------------
;		void	_blt4020r
;------------------------------------------------------------------------------
_blt4020r	proc	near
		push	edi
;		mov	edx,640*2
		mov	edx,_n80win32._vram_lpitch

		mov	eax,[esi+255*16]
		mov	ecx,eax
		mov	[edi],eax
		mov	[edi+4],ecx
		mov	[edi+edx],eax
		mov	[edi+edx+4],ecx
		mov	[edi+8],eax
		mov	[edi+12],ecx
		mov	[edi+edx+8],eax
		mov	[edi+edx+12],ecx
		add	edi,edx
		add	edi,edx

		_trr40
		_trr40
		_trr40
		_trr40
		_trr40
		_trr40
		_trr40
		_trr40

		mov	eax,[esi+255*16]
		mov	ecx,eax
		mov	[edi],eax
		mov	[edi+4],ecx
		mov	[edi+edx],eax
		mov	[edi+edx+4],ecx
		mov	[edi+8],eax
		mov	[edi+12],ecx
		mov	[edi+edx+8],eax
		mov	[edi+edx+12],ecx
		add	edi,edx

;		sub	edi,640*20-16
		pop	edi
		add	edi,16
		ret
_blt4020r	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
