;==============================================================================
;
;	PC-8001 Device Emulator for Win32 Ver 1.10
;	Copyright (C)1997 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.0
;	last modified  Jun,15,1997.
;
;	⑫FJZbgC^[tF[X
;
__CMT_ASM__	equ	1
;==============================================================================
include		n80.mac
public		_n80_cmt_buff
public		_n80_cmt_size
public		_n80_cmt_cur
;==============================================================================
_DATA		segment
		even
_n80_cmt_buff	dd	0	; buff ptr
_n80_cmt_size	dd	0	; buff size
_n80_cmt_cur	dd	0	; buff current offset ptr
_cmt_reset	db	0
_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	_cmt_command (AH:data)
;------------------------------------------------------------------------------
		public	__n80_cmt_command
__n80_cmt_command	proc	near
		push	ebp
		mov	ebp,esp
		push	esi
		push	edi
		push	ebx

		mov	eax,[ebp+8]
		mov	ah,al
		call	_cmt_command

		pop		ebx
		pop		edi
		pop		esi
		pop		ebp
		ret
__n80_cmt_command	endp

		public	_cmt_command
_cmt_command	proc	near
		cmp	ah,40h
		jne	@f
		mov	byte ptr _cmt_reset,1
@@:		ret

_cmt_command	endp
;------------------------------------------------------------------------------
;		BYTE	_cmt_read (void)
;------------------------------------------------------------------------------
		public	__n80_cmt_read
__n80_cmt_read	proc	near
		push	ebp
		push	esi
		push	edi
		push	ebx
		call	_cmt_read
		pop		ebx
		pop		edi
		pop		esi
		pop		ebp
		ret
__n80_cmt_read	endp

		public	_cmt_read
_cmt_read	proc	near
		cmp	byte ptr _cmt_reset,1	; dummy read after reset
		jne	@f
		mov	byte ptr _cmt_reset,0
		mov	al,0ffh
		movzx	eax,al
		ret
@@:		mov	ebx,_n80_cmt_buff	; no buffer
		and	ebx,ebx
		jne	@f
		mov	al,0ffh
		movzx	eax,al
		ret
@@:		mov	eax,_n80_cmt_cur	; read current data
		add	ebx,eax
		inc	eax
		cmp	[_n80_cmt_size],eax
		ja	@f
		xor	eax,eax
@@:		mov	_n80_cmt_cur,eax
		mov	al,[ebx]
		movzx	eax,al
		ret
_cmt_read	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
