;==============================================================================
;
;	PC-8001 Device Emulator for Win32 Ver 1.10
;	Copyright (C)1997 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.2
;	last modified  Jun,14,1997.
;
__VRTC_ASM__	equ	1
;==============================================================================
include		n80.mac
;STD_VDISP_END	equ	5000
;STD_VRET_END	equ	6667
public	_vrtc_flag
;==============================================================================
_DATA		segment
		even
;_VRTCSPAN	dw	STD_VRET_END
;_VRTCDISP	dw	STD_VDISP_END
;_vrtc_count	dw	0		; \݃JE^[
_vrtc_flag	db	0		; AtO
_vrtc_blink	db	30
_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	_renew_vrtc (void)
;------------------------------------------------------------------------------
		public __renew_vrtc
__renew_vrtc	proc	near
		push	esi
		push	edi
		push	ebp
		push	ebx
		call	_renew_vrtc
		pop	ebx
		pop	ebp
		pop	edi
		pop	esi
		ret
__renew_vrtc	endp

		public	_renew_vrtc
_renew_vrtc	proc	near
;		mov	ax,_vrtc_count
;		inc	ax
;		cmp	ax,6667
;		jb	@f
;		mov	byte ptr _vrtc_flag,00h		; \Jn
;		xor	ax,ax
;		mov	_vrtc_count,ax
;		ret
;@@:		mov	_vrtc_count,ax
;		cmp	ax,5000
;		jae	@f
;		ret					; \
;@@:		je	@f
;		ret					; A
;@@:		mov	byte ptr _vrtc_flag,0ffh	; AJn
;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;	J[\_œ
;;;;;;;;;;;;;;;
		dec	byte ptr _vrtc_blink
		jns	@f
		mov	byte ptr _vrtc_blink,30		; 0.5 sec
		xor	byte ptr _n80_cur_blink,1
		cmp	byte ptr _n80_cur_enable,0
		je	@f
		mov	bl,_n80_cur_row
		movzx	ebx,bl
		mov	byte ptr _attrchg[ebx],1
@@:		ret
_renew_vrtc	endp
;------------------------------------------------------------------------------
;		bool	_poll_vrtc (AL:PORT40)
;------------------------------------------------------------------------------
		public	__n80_poll_vrtc
__n80_poll_vrtc	proc	near
		push	ebp
		mov		ebp,esp
		push	esi
		push	edi
		push	ebx

		mov		eax,[ebp+8]
		call	_poll_vrtc
		movzx	eax,al

		pop		ebx
		pop		edi
		pop		esi
		pop		ebp
		ret
__n80_poll_vrtc	endp

		public	_poll_vrtc
_poll_vrtc	proc	near
		cmp	byte ptr _vrtc_flag,0
		jne	@f
		and	al,0dfh
		ret
@@:		or	al,20h
		ret
_poll_vrtc	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
