;==============================================================================
;
;	Z80 Emulator Ver 2.03
;	Copyright (C)1993-2007 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 5.0-7.0
;	last modified  Aug,19,2007.
;
;==============================================================================
include		z80em.mac
		irpc	h,<0123456789ABCDEF>
		irpc	l,<0123456789ABCDEF>
extrn		z80_&h&&l:near
		endm
		endm
;==============================================================================
_DATA		segment
		even
_dispatch	label	dword
		irpc	h,<0123456789ABCDEF>
		irpc	l,<0123456789ABCDEF>
		dd	OFFSET FLAT:z80_&h&&l
		endm
		endm
_DATA		ends
;==============================================================================
_TEXT		segment
;-----------------------------------------------------------------------------
;		int	_fetch (void)
;-----------------------------------------------------------------------------
		public	__fetch
__fetch		proc	near
;		pushad
		push	ebx
		push	esi
		push	edi
		push	ebp
;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;	HALT 
;;;;;;;;;;;;;;;
__fetch_signal:	cmp	byte ptr _z80_signal,0
		je	@f
;		popad
		pop	ebp
		pop	edi
		pop	esi
		pop	ebx
		mov	eax,1
		ret
;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;	Z80 Decode
;;;;;;;;;;;;;;;
@@:		inc	byte ptr _z80_sysclk
		mov 	dword ptr _cpu._W,0
		mov	bp,_cpu._PC
		mov	_cpu._head,bp
		_FetchB
		movzx	ebx,al
		call	DWORD PTR _dispatch[ebx*4]
;		mov	_cpu._PC,bp
;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;	Device Time
;;;;;;;;;;;;;;;
;		call	_device
;		popad
		pop	ebp
		pop	edi
		pop	esi
		pop	ebx
		xor	eax,eax
		ret

__fetch		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
