;==============================================================================
;
;	Z80 Emulator Ver 2.00
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 4.0
;	last modified  Jun,23,1996.
;
;==============================================================================
include		z80em.mac
		irpc	h,<4567>
		irpc	l,<0123456789ABCDEF>
public		z80_&h&&l
		endm
		endm
		irpc	h,<4567>
		irpc	l,<0123456789ABCDEF>
extrn		__z80_op_&h&&l:near
		endm
		endm
;==============================================================================
_TEXT		segment
;		assume	CS: _TEXT
;------------------------------------------------------------------------------
;		code	40-4F
;------------------------------------------------------------------------------
_load		proc	near

;ld_r_r		macro	d,s
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu.&s
;		mov	_cpu.&d,al
;		ret
;		endm

;ld_r_hl		macro	r
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._HL
;		call	_mbread
;		mov	_cpu.&r,al
;		ret
;		endm

z80_40		label	near			; LD B,B
;		mov	DWORD PTR _cpu._T,5
;		ret
		call	__z80_op_40
		ret
z80_41		label	near			; LD B,C
;		ld_r_r	_B,_C
		call	__z80_op_41
		ret
z80_42		label	near			; LD B,D
;		ld_r_r	_B,_D
		call	__z80_op_42
		ret
z80_43		label	near			; LD B,E
;		ld_r_r	_B,_E
		call	__z80_op_43
		ret
z80_44		label	near			; LD B,H
;		ld_r_r	_B,_H
		call	__z80_op_44
		ret
z80_45		label	near			; LD B,L
;		ld_r_r	_B,_L
		call	__z80_op_45
		ret
z80_46		label	near			; LD B,(HL)
;		ld_r_hl	_B
		call	__z80_op_46
		ret
z80_47		label	near			; LD B,A
;		ld_r_r	_B,_A
		call	__z80_op_47
		ret
z80_48		label	near			; LD C,B
;		ld_r_r	_C,_B
		call	__z80_op_48
		ret
z80_49		label	near			; LD C,C
;		mov	DWORD PTR _cpu._T,5
;		ret
		call	__z80_op_49
		ret
z80_4A		label	near			; LD C,D
;		ld_r_r	_C,_D
		call	__z80_op_4A
		ret
z80_4B		label	near			; LD C,E
;		ld_r_r	_C,_E
		call	__z80_op_4B
		ret
z80_4C		label	near			; LD C,H
;		ld_r_r	_C,_H
		call	__z80_op_4C
		ret
z80_4D		label	near			; LD C,L
;		ld_r_r	_C,_L
		call	__z80_op_4D
		ret
z80_4E		label	near			; LD C,(HL)
;		ld_r_hl	_C
		call	__z80_op_4E
		ret
z80_4F		label	near			; LD C,A
;		ld_r_r	_C,_A
		call	__z80_op_4F
		ret
;------------------------------------------------------------------------------
;		code	50-5F
;------------------------------------------------------------------------------
z80_50		label	near			; LD D,B
;		ld_r_r	_D,_B
		call	__z80_op_50
		ret
z80_51		label	near			; LD D,C
;		ld_r_r	_D,_C
		call	__z80_op_51
		ret
z80_52		label	near			; LD D,D
;		mov	DWORD PTR _cpu._T,5
;		ret
		call	__z80_op_52
		ret
z80_53		label	near			; LD D,E
;		ld_r_r	_D,_E
		call	__z80_op_53
		ret
z80_54		label	near			; LD D,H
;		ld_r_r	_D,_H
		call	__z80_op_54
		ret
z80_55		label	near			; LD D,L
;		ld_r_r	_D,_L
		call	__z80_op_55
		ret
z80_56		label	near			; LD D,(HL)
;		ld_r_hl	_D
		call	__z80_op_56
		ret
z80_57		label	near			; LD D,A
;		ld_r_r	_D,_A
		call	__z80_op_57
		ret
z80_58		label	near			; LD E,B
;		ld_r_r	_E,_B
		call	__z80_op_58
		ret
z80_59		label	near			; LD E,C
;		ld_r_r	_E,_C
		call	__z80_op_59
		ret
z80_5A		label	near			; LD E,D
;		ld_r_r	_E,_D
		call	__z80_op_5A
		ret
z80_5B		label	near			; LD E,E
;		mov	DWORD PTR _cpu._T,5
;		ret
		call	__z80_op_5B
		ret
z80_5C		label	near			; LD E,H
;		ld_r_r	_E,_H
		call	__z80_op_5C
		ret
z80_5D		label	near			; LD E,L
;		ld_r_r	_E,_L
		call	__z80_op_5D
		ret
z80_5E		label	near			; LD E,(HL)
;		ld_r_hl	_E
		call	__z80_op_5E
		ret
z80_5F		label	near			; LD E,A
;		ld_r_r	_E,_A
		call	__z80_op_5F
		ret
;------------------------------------------------------------------------------
;		code	60-6F
;------------------------------------------------------------------------------
z80_60		label	near			; LD H,B
;		ld_r_r	_H,_B
		call	__z80_op_60
		ret
z80_61		label	near			; LD H,C
;		ld_r_r	_H,_C
		call	__z80_op_61
		ret
z80_62		label	near			; LD H,D
;		ld_r_r	_H,_D
		call	__z80_op_62
		ret
z80_63		label	near			; LD H,E
;		ld_r_r	_H,_E
		call	__z80_op_63
		ret
z80_64		label	near			; LD H,H
;		mov	DWORD PTR _cpu._T,5
;		ret
		call	__z80_op_64
		ret
z80_65		label	near			; LD H,L
;		ld_r_r	_H,_L
		call	__z80_op_65
		ret
z80_66		label	near			; LD H,(HL)
;		ld_r_hl	_H
		call	__z80_op_66
		ret
z80_67		label	near			; LD H,A
;		ld_r_r	_H,_A
		call	__z80_op_67
		ret
z80_68		label	near			; LD L,B
;		ld_r_r	_L,_B
		call	__z80_op_68
		ret
z80_69		label	near			; LD L,C
;		ld_r_r	_L,_C
		call	__z80_op_69
		ret
z80_6A		label	near			; LD L,D
;		ld_r_r	_L,_D
		call	__z80_op_6A
		ret
z80_6B		label	near			; LD L,E
;		ld_r_r	_L,_E
		call	__z80_op_6B
		ret
z80_6C		label	near			; LD L,H
;		ld_r_r	_L,_H
		call	__z80_op_6C
		ret
z80_6D		label	near			; LD L,L
;		mov	DWORD PTR _cpu._T,5
;		ret
		call	__z80_op_6D
		ret
z80_6E		label	near			; LD L,(HL)
;		ld_r_hl	_L
		call	__z80_op_6E
		ret
z80_6F		label	near			; LD L,A
;		ld_r_r	_L,_A
		call	__z80_op_6F
		ret
;------------------------------------------------------------------------------
;		code	70-7F
;------------------------------------------------------------------------------
;ld_hl_r		macro	r
;		mov	DWORD PTR _cpu._T,8
;		mov	bl,_cpu.&r
;		mov	ax,_cpu._HL
;		call	_mbwrite
;		ret
;		endm

z80_70		label	near			; LD (HL),B
;		ld_hl_r	_B
		call	__z80_op_70
		ret
z80_71		label	near			; LD (HL),C
;		ld_hl_r	_C
		call	__z80_op_71
		ret
z80_72		label	near			; LD (HL),D
;		ld_hl_r	_D
		call	__z80_op_72
		ret
z80_73		label	near			; LD (HL),E
;		ld_hl_r	_E
		call	__z80_op_73
		ret
z80_74		label	near			; LD (HL),H
;		ld_hl_r	_H
		call	__z80_op_74
		ret
z80_75		label	near			; LD (HL),L
;		ld_hl_r	_L
		call	__z80_op_75
		ret
z80_77		label	near			; LD (HL),A
;		ld_hl_r	_A
		call	__z80_op_77
		ret
z80_78		label	near			; LD A,B
;		ld_r_r	_A,_B
		call	__z80_op_78
		ret
z80_79		label	near			; LD A,C
;		ld_r_r	_A,_C
		call	__z80_op_79
		ret
z80_7A		label	near			; LD A,D
;		ld_r_r	_A,_D
		call	__z80_op_7A
		ret
z80_7B		label	near			; LD A,E
;		ld_r_r	_A,_E
		call	__z80_op_7B
		ret
z80_7C		label	near			; LD A,H
;		ld_r_r	_A,_H
		call	__z80_op_7C
		ret
z80_7D		label	near			; LD A,L
;		ld_r_r	_A,_L
		call	__z80_op_7D
		ret
z80_7E		label	near			; LD A,(HL)
;		ld_r_hl	_A
		call	__z80_op_7E
		ret
z80_7F		label	near			; LD A,A
;		mov	DWORD PTR _cpu._T,5
;		ret
		call	__z80_op_7F
		ret
;------------------------------------------------------------------------------
;		HALT instruction
;------------------------------------------------------------------------------
z80_76		label	near
		mov	DWORD PTR _cpu._T,5
		mov	BYTE PTR _z80_signal,_EXITBIT
		mov	BYTE PTR _cpu._HALT,_HALT76
		ret
_load		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
