;==============================================================================
;
;	Z80 Emulator Ver 2.00
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 4.0
;	last modified  Jun,23,1996.
;
;==============================================================================
include		z80em.mac
include		flag.mac
		irpc	h,<89AB>
		irpc	l,<0123456789ABCDEF>
public		z80_&h&&l
		endm
		endm
		irpc	h,<89AB>
		irpc	l,<0123456789ABCDEF>
extrn		__z80_op_&h&&l:near
		endm
		endm
;==============================================================================
_TEXT		segment
;		assume	CS: _TEXT
;------------------------------------------------------------------------------
;		code	80-87
;------------------------------------------------------------------------------
_math		proc	near

;add_r		macro	r
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu.&r
;		add	_cpu._A,al
;		pushf
;		_addf
;		endm

z80_80		label	near			; ADD A,B
;		add_r	_B
		call	__z80_op_80
		ret
z80_81		label	near			; ADD A,C
;		add_r	_C
		call	__z80_op_81
		ret
z80_82		label	near			; ADD A,D
;		add_r	_D
		call	__z80_op_82
		ret
z80_83		label	near			; ADD A,E
;		add_r	_E
		call	__z80_op_83
		ret
z80_84		label	near			; ADD A,H
;		add_r	_H
		call	__z80_op_84
		ret
z80_85		label	near			; ADD A,L
;		add_r	_L
		call	__z80_op_85
		ret
z80_87		label	near			; ADD A,A
;		add_r	_A
		call	__z80_op_87
		ret
z80_86		label	near			; ADD A,(HL)
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._HL
;		call	_mbread
;		add	_cpu._A,al
;		pushf
;		_addf
		call	__z80_op_86
		ret

;adc_r		macro	r
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu.&r
;		bt	DWORD PTR _cpu._F,_CY
;		adc	_cpu._A,al
;		pushf
;		_addf
;		endm

z80_88		label	near			; ADC A,B
;		adc_r	_B
		call	__z80_op_88
		ret
z80_89		label	near			; ADC A,C
;		adc_r	_C
		call	__z80_op_89
		ret
z80_8A		label	near			; ADC A,D
;		adc_r	_D
		call	__z80_op_8A
		ret
z80_8B		label	near			; ADC A,E
;		adc_r	_E
		call	__z80_op_8B
		ret
z80_8C		label	near			; ADC A,H
;		adc_r	_H
		call	__z80_op_8C
		ret
z80_8D		label	near			; ADC A,L
;		adc_r	_L
		call	__z80_op_8D
		ret
z80_8F		label	near			; ADC A,A
;		adc_r	_A
		call	__z80_op_8F
		ret
z80_8E		label	near			; ADC A,(HL)
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._HL
;		call	_mbread
;		bt	DWORD PTR _cpu._F,_CY
;		adc	_cpu._A,al
;		pushf
;		_addf
		call	__z80_op_8E
		ret
;------------------------------------------------------------------------------
;		code	90-9F
;------------------------------------------------------------------------------
;sub_r		macro	r
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu.&r
;		sub	_cpu._A,al
;		pushf
;		_subf
;		endm

z80_90		label	near			; SUB A,B
;		sub_r	_B
		call	__z80_op_90
		ret
z80_91		label	near			; SUB A,C
;		sub_r	_C
		call	__z80_op_91
		ret
z80_92		label	near			; SUB A,D
;		sub_r	_D
		call	__z80_op_92
		ret
z80_93		label	near			; SUB A,E
;		sub_r	_E
		call	__z80_op_93
		ret
z80_94		label	near			; SUB A,H
;		sub_r	_H
		call	__z80_op_94
		ret
z80_95		label	near			; SUB A,L
;		sub_r	_L
		call	__z80_op_95
		ret
z80_97		label	near			; SUB A,A
;		sub_r	_A
		call	__z80_op_97
		ret
z80_96		label	near			; SUB A,(HL)
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._HL
;		call	_mbread
;		sub	_cpu._A,al
;		pushf
;		_subf
		call	__z80_op_96
		ret

;sbc_r		macro	r
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu.&r
;		bt	DWORD PTR _cpu._F,_CY
;		sbb	_cpu._A,al
;		pushf
;		_subf
;		endm

z80_98		label	near			; SBC A,B
;		sbc_r	_B
		call	__z80_op_98
		ret
z80_99		label	near			; SBC A,C
;		sbc_r	_C
		call	__z80_op_99
		ret
z80_9A		label	near			; SBC A,D
;		sbc_r	_D
		call	__z80_op_9A
		ret
z80_9B		label	near			; SBC A,E
;		sbc_r	_E
		call	__z80_op_9B
		ret
z80_9C		label	near			; SBC A,H
;		sbc_r	_H
		call	__z80_op_9C
		ret
z80_9D		label	near			; SBC A,L
;		sbc_r	_L
		call	__z80_op_9D
		ret
z80_9F		label	near			; SBC A,A
;		sbc_r	_A
		call	__z80_op_9F
		ret
z80_9E		label	near			; SBC A,(HL)
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._HL
;		call	_mbread
;		bt	DWORD PTR _cpu._F,_CY
;		sbb	_cpu._A,al
;		pushf
;		_subf
		call	__z80_op_9E
		ret
;------------------------------------------------------------------------------
;		code	A0-AF
;------------------------------------------------------------------------------
;and_r		macro	r
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu.&r
;		and	_cpu._A,al
;		pushf
;		_andf
;		endm

z80_A0		label	near			; AND A,B
;		and_r	_B
		call	__z80_op_A0
		ret
z80_A1		label	near			; AND A,C
;		and_r	_C
		call	__z80_op_A1
		ret
z80_A2		label	near			; AND A,D
;		and_r	_D
		call	__z80_op_A2
		ret
z80_A3		label	near			; AND A,E
;		and_r	_E
		call	__z80_op_A3
		ret
z80_A4		label	near			; AND A,H
;		and_r	_H
		call	__z80_op_A4
		ret
z80_A5		label	near			; AND A,L
;		and_r	_L
		call	__z80_op_A5
		ret
z80_A7		label	near			; AND A,A
;		and_r	_A
		call	__z80_op_A7
		ret
z80_A6		label	near			; AND A,(HL)
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._HL
;		call	_mbread
;		and	_cpu._A,al
;		pushf
;		_andf
		call	__z80_op_A6
		ret

;xor_r		macro	r
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu.&r
;		xor	_cpu._A,al
;		pushf
;		_orf
;		endm

z80_A8		label	near			; XOR A,B
;		xor_r	_B
		call	__z80_op_A8
		ret
z80_A9		label	near			; XOR A,C
;		xor_r	_C
		call	__z80_op_A9
		ret
z80_AA		label	near			; XOR A,D
;		xor_r	_D
		call	__z80_op_AA
		ret
z80_AB		label	near			; XOR A,E
;		xor_r	_E
		call	__z80_op_AB
		ret
z80_AC		label	near			; XOR A,H
;		xor_r	_H
		call	__z80_op_AC
		ret
z80_AD		label	near			; XOR A,L
;		xor_r	_L
		call	__z80_op_AD
		ret
z80_AF		label	near			; XOR A,A
;		xor_r	_A
		call	__z80_op_AF
		ret
z80_AE		label	near			; XOR A,(HL)
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._HL
;		call	_mbread
;		xor	_cpu._A,al
;		pushf
;		_orf
		call	__z80_op_AE
		ret
;------------------------------------------------------------------------------
;		code	B0-BF
;------------------------------------------------------------------------------
;or_r		macro	r
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu.&r
;		or	_cpu._A,al
;		pushf
;		_orf
;		endm

z80_B0		label	near			; OR A,B
;		or_r	_B
		call	__z80_op_B0
		ret
z80_B1		label	near			; OR A,C
;		or_r	_C
		call	__z80_op_B1
		ret
z80_B2		label	near			; OR A,D
;		or_r	_D
		call	__z80_op_B2
		ret
z80_B3		label	near			; OR A,E
;		or_r	_E
		call	__z80_op_B3
		ret
z80_B4		label	near			; OR A,H
;		or_r	_H
		call	__z80_op_B4
		ret
z80_B5		label	near			; OR A,L
;		or_r	_L
		call	__z80_op_B5
		ret
z80_B7		label	near			; OR A,A
;		or_r	_A
		call	__z80_op_B7
		ret
z80_B6		label	near			; OR A,(HL)
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._HL
;		call	_mbread
;		or	_cpu._A,al
;		pushf
;		_orf
		call	__z80_op_B6
		ret

;cp_r		macro	r
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu.&r
;		cmp	_cpu._A,al
;		pushf
;		_subf
;		endm

z80_B8		label	near			; CP A,B
;		cp_r	_B
		call	__z80_op_B8
		ret
z80_B9		label	near			; CP A,C
;		cp_r	_C
		call	__z80_op_B9
		ret
z80_BA		label	near			; CP A,D
;		cp_r	_D
		call	__z80_op_BA
		ret
z80_BB		label	near			; CP A,E
;		cp_r	_E
		call	__z80_op_BB
		ret
z80_BC		label	near			; CP A,H
;		cp_r	_H
		call	__z80_op_BC
		ret
z80_BD		label	near			; CP A,L
;		cp_r	_L
		call	__z80_op_BD
		ret
z80_BF		label	near			; CP A,A
;		cp_r	_A
		call	__z80_op_BF
		ret
z80_BE		label	near			; CP A,(HL)
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._HL
;		call	_mbread
;		cmp	_cpu._A,al
;		pushf
;		_subf
		call	__z80_op_BE
		ret

_math		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
