;==============================================================================
;
;	Z80 Emulator Ver 2.00
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 4.00
;	last modified  Jun,23,1996.
;
;==============================================================================
include		z80em.mac
include		flag.mac
		irpc	h,<245689AB>		; see also OP2B.ASM
		irpc	l,<45CD>
public		XD_&h&&l
		endm
		endm
		irpc	l,<0123789ABF>
public		XD_6&l
		endm
public		XD_26,XD_2E,XD_7C,XD_7D
;==============================================================================
_TEXT		segment
;		assume	CS: _TEXT
;------------------------------------------------------------------------------
;		void	z80_DD/FD (void)
;------------------------------------------------------------------------------
_undef		proc	near
;------------------------------------------------------------------------------
;		add/sub routines
;------------------------------------------------------------------------------
XD_84		label	near			; ADD A,IXH
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi+1]
		add	_cpu._A,al
		pushf
		_addf
XD_8C		label	near			; ADC A,IXH
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi+1]
		bt	DWORD PTR _cpu._F,_CY
		adc	_cpu._A,al
		pushf
		_addf
XD_94		label	near			; SUB A,IXH
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi+1]
		sub	_cpu._A,al
		pushf
		_subf
XD_9C		label	near			; SBC A,IXH
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi+1]
		bt	DWORD PTR _cpu._F,_CY
		sbb	_cpu._A,al
		pushf
		_subf
XD_A4		label	near			; AND A,IXH
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi+1]
		and	_cpu._A,al
		pushf
		_andf
XD_AC		label	near			; XOR A,IXH
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi+1]
		xor	_cpu._A,al
		pushf
		_orf
XD_B4		label	near			; OR A,IXH
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi+1]
		or	_cpu._A,al
		pushf
		_orf
XD_BC		label	near			; CP A,IXH
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi+1]
		cmp	_cpu._A,al
		pushf
		_subf

XD_85		label	near			; ADD A,IXL
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi]
		add	_cpu._A,al
		pushf
		_addf
XD_8D		label	near			; ADC A,IXL
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi]
		bt	DWORD PTR _cpu._F,_CY
		adc	_cpu._A,al
		pushf
		_addf
XD_95		label	near			; SUB A,IXL
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi]
		sub	_cpu._A,al
		pushf
		_subf
XD_9D		label	near			; SBC A,IXL
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi]
		bt	DWORD PTR _cpu._F,_CY
		sbb	_cpu._A,al
		pushf
		_subf
XD_A5		label	near			; AND A,IXL
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi]
		and	_cpu._A,al
		pushf
		_andf
XD_AD		label	near			; XOR A,IXL
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi]
		xor	_cpu._A,al
		pushf
		_orf
XD_B5		label	near			; OR A,IXL
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi]
		or	_cpu._A,al
		pushf
		_orf
XD_BD		label	near			; CP A,IXL
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi]
		cmp	_cpu._A,al
		pushf
		_subf
;------------------------------------------------------------------------------
;		inc/dec routines
;------------------------------------------------------------------------------
XD_24		label	near			; INC IXH, INC IYH
		mov	DWORD PTR _cpu._T,5+2
		bt	DWORD PTR _cpu._F,_CY
		inc	BYTE PTR [esi+1]
		pushf
		_addf

XD_2C		label	near			; INC IXL, INC IYL
		mov	DWORD PTR _cpu._T,5+2
		bt	DWORD PTR _cpu._F,_CY
		inc	BYTE PTR [esi]
		pushf
		_addf

XD_25		label	near			; DEC IXH, DEC IYH
		mov	DWORD PTR _cpu._T,5+2
		bt	DWORD PTR _cpu._F,_CY
		dec	BYTE PTR [esi+1]
		pushf
		_subf

XD_2D		label	near			; DEC IXL, DEX IYL
		mov	DWORD PTR _cpu._T,5+2
		bt	DWORD PTR _cpu._F,_CY
		dec	BYTE PTR [esi]
		pushf
		_subf
;------------------------------------------------------------------------------
;		load routines
;------------------------------------------------------------------------------
XD_26		label	near			; LD IXH,n, LD IYH,n
		mov	DWORD PTR _cpu._T,8+2
		_FetchB
		mov	[esi+1],al
		ret

XD_2E		label	near			; LD IXL,n, LD IYL,n
		mov	DWORD PTR _cpu._T,8+2
		_FetchB
		mov	[esi],al
		ret

ld_r_ixh	macro	r
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi+1]
		mov	_cpu.&r,al
		ret
		endm

ld_r_ixl	macro	r
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi]
		mov	_cpu.&r,al
		ret
		endm

XD_44		label	near			; LD B,IXH
		ld_r_ixh _B
XD_4C		label	near			; LD C,IXH
		ld_r_ixh _C
XD_54		label	near			; LD D,IXH
		ld_r_ixh _D
XD_5C		label	near			; LD E,IXH
		ld_r_ixh _E
XD_7C		label	near			; LD A,IXH
		ld_r_ixh _A

XD_45		label	near			; LD B,IXL
		ld_r_ixl _B
XD_4D		label	near			; LD C,IXL
		ld_r_ixl _C
XD_55		label	near			; LD D,IXL
		ld_r_ixl _D
XD_5D		label	near			; LD E,IXL
		ld_r_ixl _E
XD_7D		label	near			; LD A,IXL
		ld_r_ixl _A

ld_ixh_r	macro	r
		mov	DWORD PTR _cpu._T,5+2
		mov	al,_cpu.&r
		mov	[esi+1],al
		ret
		endm

ld_ixl_r	macro	r
		mov	DWORD PTR _cpu._T,5+2
		mov	al,_cpu.&r
		mov	[esi],al
		ret
		endm

XD_60		label	near			; LD IXH,B
		ld_ixh_r _B
XD_61		label	near			; LD IXH,C
		ld_ixh_r _C
XD_62		label	near			; LD IXH,D
		ld_ixh_r _D
XD_63		label	near			; LD IXH,E
		ld_ixh_r _E
XD_67		label	near			; LD IXH,A
		ld_ixh_r _A
XD_64		label	near			; LD IXH,IXH
		mov	DWORD PTR _cpu._T,5+2
		ret
XD_65		label	near			; LD IXH,IXL
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi]
		mov	[esi+1],al
		ret

XD_68		label	near			; LD IXL,B
		ld_ixl_r _B
XD_69		label	near			; LD IXL,C
		ld_ixl_r _C
XD_6A		label	near			; LD IXL,D
		ld_ixl_r _D
XD_6B		label	near			; LD IXL,E
		ld_ixl_r _E
XD_6F		label	near			; LD IXL,A
		ld_ixl_r _A
XD_6C		label	near			; LD IXL,IXH
		mov	DWORD PTR _cpu._T,5+2
		mov	al,[esi+1]
		mov	[esi],al
		ret
XD_6D		label	near			; LD IXL,IXL
		mov	DWORD PTR _cpu._T,5+2
		ret

_undef		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
