;==============================================================================
;
;	PC-8001 Device Emulator Ver 1.11
;	Copyright (C)1993-2007 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.2
;	last modified  Aug,18,2007.
;
__BLT_ASM__	equ	1
;==============================================================================
include		n80.mac
;public		_n80_vram_addr
;public		_n80_vram_lpitch
;public		_vtbl_vram20
;public		_vtbl_vram25
extrn		_blt4020:near
extrn		_blt4025:near
extrn		_blt8020:near
extrn		_blt8025:near
;extrn		_blt4020x:near
;extrn		_blt4025x:near
;extrn		_blt8020x:near
;extrn		_blt8025x:near
;==============================================================================
_DATA		segment
		even
_blt_func	dd	offset FLAT:_blt4020
_blt_table	dd	offset FLAT:_blt4020
		dd	offset FLAT:_blt4025
		dd	offset FLAT:_blt8020
		dd	offset FLAT:_blt8025
;_blt_tablex	dd	offset FLAT:_blt4020x
;		dd	offset FLAT:_blt4025x
;		dd	offset FLAT:_blt8020x
;		dd	offset FLAT:_blt8025x
;_n80_vram_addr	dd	0
;_n80_vram_lpitch dd	0
;_vtbl_vram20	dd	20 dup (?)
;_vtbl_vram25	dd	25 dup (?)
_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	__blt_font (line)
;------------------------------------------------------------------------------
;	ebx = eval_table, text_table ptr
;	edi = video ram address			# set before calling
;	esi = pattern address
;	ebp = original font address
;------------------------------------------------------------------------------
		public	__blt_font
__blt_font	proc	near
		push	ebp
		mov	ebp,esp
		push	esi
		push	edi
		push	ebx
		mov	eax,[ebp+8]		; eax = line
		mov	ebx,[ebp+12]	; ebx = _eval_attr

;		mov	ebx,offset FLAT:_eval_attr

		push	eax
		call	[_blt_func]
		add		esp,4

		pop	ebx
		pop	edi
		pop	esi
		pop	ebp
		ret
__blt_font	endp
;------------------------------------------------------------------------------
;		void	_chg_bltfunc ()
;------------------------------------------------------------------------------
		public	_chg_bltfunc
_chg_bltfunc	proc	near
;		push	ebx
		push	ebp
		mov	ebp,esp
		push	esi
		push	edi
		push	ebx
		mov	ebx,[ebp+8]		; eax = _n80_scrn_mode

;		mov	ebx,_n80_scrn_mode
		mov	ebx,_blt_table[ebx*4]
		mov	_blt_func,ebx

		pop	ebx
		pop	edi
		pop	esi
		pop	ebp
			
;		pop	ebx
		ret
_chg_bltfunc	endp
;------------------------------------------------------------------------------
;		void	__blt_mmx ()
;------------------------------------------------------------------------------
;		public	__blt_mmx
;__blt_mmx	proc	near
;		mov	eax,_blt_tablex[0]
;		mov	_blt_table[0],eax
;		mov	eax,_blt_tablex[4]
;		mov	_blt_table[4],eax
;		mov	eax,_blt_tablex[8]
;		mov	_blt_table[8],eax
;		mov	eax,_blt_tablex[12]
;		mov	_blt_table[12],eax
;		ret
;__blt_mmx	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
