;==============================================================================
;
;	PC-8001 Device Emulator Ver 1.10
;	Copyright (C)1993-97 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.2
;	last modified  Jun,16,1997.
;
__BLT8025_ASM__	equ	1
;==============================================================================
include		n80.mac
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	_blt8025 (eax:line)
;------------------------------------------------------------------------------
;	ebx = eval_table, text_table ptr
;	edi = video ram address			# set before calling
;	esi = pattern address
;	ebp = original font address
;------------------------------------------------------------------------------
		public	_blt8025
_blt8025	proc	near
		mov	edi,_n80win32._vram_addr
;		add	edi,_vtbl_vram25[eax*4]
		add	edi,_n80win32._vtbl_vram25[eax*4]
		mov	ebp,offset FLAT:_n80device._fnt
		mov	ecx,80
_blt8025_0:	push	ebp
		push	ebx
		push	ecx
;;;;;;;;;;;;;;;;
		mov	al,[ebx]	; PAC
		mov	ah,[ebx+80]	; 8bit-ascii code

		mov	cl,al		; color -> pattern_table
		and	cl,07h
		movzx	esi,cl
		mov	esi,_n80win32._vtbl_patt80[esi*4]

		movzx	edx,ah		; ascii -> font address
		test	al,10h
		jz	_blt8025_1
		add	edx,256
		jmp	@f
_blt8025_1:	cmp	byte ptr _n80device._pcg_mode,0
		je	@f
		add	edx,512
@@:		shl	edx,3
		add	ebp,edx

		test	al,20h		; branch by graf bit
		jnz	@f
		call	_blt8025n
		jmp	_blt8025_2
@@:		call	_blt8025r
_blt8025_2:	nop
;;;;;;;;;;;;;;;;
		pop	ecx
		pop	ebx
		pop	ebp
		inc	ebx
		loop	_blt8025_0
		ret
_blt8025	endp
;------------------------------------------------------------------------------
;		void	_blt8025a
;------------------------------------------------------------------------------
_blt8025n	proc	near
		push	edi
;		mov	edx,640
		mov	edx,_n80win32._vram_lpitch
		_trn80
		_trn80
		_trn80
		_trn80
		_trn80
		_trn80
		_trn80
		_trn80
;		sub	edi,640*16-8
		pop	edi
		add	edi,8
		ret
_blt8025n	endp
;------------------------------------------------------------------------------
;		void	_blt8025r
;------------------------------------------------------------------------------
_blt8025r	proc	near
		push	edi
;		mov	edx,640
		mov	edx,_n80win32._vram_lpitch
		_trr80
		_trr80
		_trr80
		_trr80
		_trr80
		_trr80
		_trr80
		_trr80
;		sub	edi,640*16-8
		pop	edi
		add	edi,8
		ret
_blt8025r	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
