;==============================================================================
;
;	PC-8001 Device Emulator Ver 1.10
;	Copyright (C)1993-97 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.2
;	last modified  Jun,15,1997.
;
__DEVICE_ASM__	equ	1
;==============================================================================
include		n80.mac
public		_n80_helz_base
public		_n80_tick_base
public		_n80_flip_base
;extrn		_transfer:near
;==============================================================================
_DATA		segment
		even
_n80_helz_base	dd	3993600	; Z80 CPU Clock (4MHz default)
_n80_tick_base	dd	100	; wait loop per Z80 state clocks
_n80_flip_base	dd	60	; 60fps
;flip_count	dd	0
;flip_limiter	db	0
_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	_device (void)
;------------------------------------------------------------------------------
		public	_device
_device		proc	near
;		call	_renew_vrtc
		call	_attrib
;		and	eax,eax
;		je	_device_nochg
;		mov	byte ptr flip_limiter,0
;		dec	dword ptr flip_count
;		jns	@f
;		mov	eax,_n80_flip_base
;		mov	flip_count,eax
;		call	_transfer
@@:		ret

;_device_nochg:	cmp	byte ptr flip_limiter,1
;		je	@f
;		dec	dword ptr flip_count
;		jns	@f
;		mov	eax,_n80_flip_base
;		mov	flip_count,eax
;		mov	byte ptr flip_limiter,1
;		call	_transfer
;@@:		ret
_device		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
