;==============================================================================
;
;	Z80 Emulator Ver 2.00
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 4.0
;	last modified  Jun,23,1996.
;
;==============================================================================
include		z80em.mac
;==============================================================================
_TEXT		segment
;-----------------------------------------------------------------------------
;		bool  _int_signal (AL:vector)
;-----------------------------------------------------------------------------
		public	_int_signal
_int_signal	proc	near
		cmp	BYTE PTR _cpu._IFF1,0
		je	@f
		cmp	BYTE PTR _cpu._IFF2,0
		je	@f
		mov	BYTE PTR _cpu._IFF1,0	; auto DI execute
		mov	BYTE PTR _cpu._IFF2,0
		or	BYTE PTR _z80_signal,02h
		shl	al,1			; get addr from vector
		mov	ah,_cpu._I
		call	_mwread
		mov	_cpu._PC,ax
		clc				; CY=0  ACCEPTED
		ret
@@:		stc				; CY=1  IGNORED
		ret
_int_signal	endp
;-----------------------------------------------------------------------------
;		bool  _nmi_signal (void)
;-----------------------------------------------------------------------------
		public	_nmi_signal
_nmi_signal	proc	near
		mov	BYTE PTR _cpu._IFF1,0
		mov	WORD PTR _cpu._PC,0066h
		or	BYTE PTR _z80_signal,01h
		ret
_nmi_signal	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
