;==============================================================================
;
;	Z80 Emulator Ver 2.00
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 4.0
;	last modified  Jun,23,1996.
;
;==============================================================================
include		z80em.mac
include		flag.mac
		irpc	h,<CDEF>
		irpc	l,<0123456789ACEF>
public		z80_&h&&l
		endm
		endm
public		z80_CD,z80_DB,z80_EB,z80_FB
		irpc	h,<CDEF>
		irpc	l,<01245678ACEF>
extrn		__z80_op_&h&&l:near
		endm
		endm
extrn		__z80_op_C3:near
extrn		__z80_op_C9:near
extrn		__z80_op_CD:near
extrn		__z80_op_D3:near
extrn		__z80_op_D9:near
extrn		__z80_op_DB:near
extrn		__z80_op_E3:near
extrn		__z80_op_E9:near
extrn		__z80_op_EB:near
extrn		__z80_op_F3:near
extrn		__z80_op_F9:near
extrn		__z80_op_FB:near
;==============================================================================
_TEXT		segment
;		assume	CS: _TEXT
;------------------------------------------------------------------------------
;		RET  cc
;------------------------------------------------------------------------------
_8080B		proc	near

;retcc		macro	cc
;		test	BYTE PTR _cpu._F,cc
;		jnz	pre_ret
;		mov	DWORD PTR _cpu._T,6
;		ret
;		endm

;retncc		macro	cc
;		test	BYTE PTR _cpu._F,cc
;		jz	pre_ret
;		mov	DWORD PTR _cpu._T,6
;		ret
;		endm

z80_C0		label	near			; RET NZ
;		retncc	_bZ
		call	__z80_op_C0
		ret
z80_D0		label	near			; RET NC
;		retncc	_bC
		call	__z80_op_D0
		ret
z80_E0		label	near			; RET PO
;		retncc	_bP
		call	__z80_op_E0
		ret
z80_F0		label	near			; RET P
;		retncc	_bS
		call	__z80_op_F0
		ret
z80_C8		label	near			; RET Z
;		retcc	_bZ
		call	__z80_op_C8
		ret
z80_D8		label	near			; RET C
;		retcc	_bC
		call	__z80_op_D8
		ret
z80_E8		label	near			; RET PE
;		retcc	_bP
		call	__z80_op_E8
		ret
z80_F8		label	near			; RET M
;		retcc	_bS
		call	__z80_op_F8
		ret

z80_C9		label	near			; RET
;pre_ret:	_PopW
;		mov	bp,ax
;		mov	_cpu._PC,bp
;		mov	DWORD PTR _cpu._T,12
;		ret
		call	__z80_op_C9
		ret
;------------------------------------------------------------------------------
;		JP  cc,nn
;------------------------------------------------------------------------------
;jpcc		macro	cc
;		local	jpcc_exit
;		_FetchW
;		test	BYTE PTR _cpu._F,cc
;		jz	jpcc_exit
;		mov	bp,ax
;		mov	_cpu._PC,bp
;jpcc_exit:	mov	DWORD PTR _cpu._T,11
;		ret
;		endm

;jpncc		macro	cc
;		local	jpncc_exit
;		_FetchW
;		test	BYTE PTR _cpu._F,cc
;		jnz	jpncc_exit
;		mov	bp,ax
;		mov	_cpu._PC,bp
;jpncc_exit:	mov	DWORD PTR _cpu._T,11
;		ret
;		endm

z80_C2		label	near			; JP NZ,nn
;		jpncc	_bZ
		call	__z80_op_C2
		ret
z80_D2		label	near			; JP NC,nn
;		jpncc	_bC
		call	__z80_op_D2
		ret
z80_E2		label	near			; JP PO,nn
;		jpncc	_bP
		call	__z80_op_E2
		ret
z80_F2		label	near			; JP P,nn
;		jpncc	_bS
		call	__z80_op_F2
		ret
z80_CA		label	near			; JP Z,nn
;		jpcc	_bZ
		call	__z80_op_CA
		ret
z80_DA		label	near			; JP C,nn
;		jpcc	_bC
		call	__z80_op_DA
		ret
z80_EA		label	near			; JP PE,nn
;		jpcc	_bP
		call	__z80_op_EA
		ret
z80_FA		label	near			; JP M,nn
;		jpcc	_bS
		call	__z80_op_FA
		ret

z80_C3		label	near			; JP nn
;		mov	DWORD PTR _cpu._T,11
;		_FetchW
;		mov	bp,ax
;		mov	_cpu._PC,bp
;		ret
		call	__z80_op_C3
		ret
z80_E9		label	near			; JP (HL)
;		mov	DWORD PTR _cpu._T,5
;		mov	bp,_cpu._HL
;		mov	_cpu._PC,bp
;		ret
		call	__z80_op_E9
		ret
;------------------------------------------------------------------------------
;		CALL  cc,nn
;------------------------------------------------------------------------------
;callcc		macro	cc
;		_FetchW
;		test	BYTE PTR _cpu._F,cc
;		jnz	pre_call
;		mov	DWORD PTR _cpu._T,11
;		ret
;		endm

;callncc		macro	cc
;		_FetchW
;		test	BYTE PTR _cpu._F,cc
;		jz	pre_call
;		mov	DWORD PTR _cpu._T,11
;		ret
;		endm

z80_C4		label	near			; CALL NZ,nn
;		callncc	_bZ
		call	__z80_op_C4
		ret
z80_D4		label	near			; CALL NC,nn
;		callncc	_bC
		call	__z80_op_D4
		ret
z80_E4		label	near			; CALL PO,nn
;		callncc	_bP
		call	__z80_op_E4
		ret
z80_F4		label	near			; CALL P,nn
;		callncc	_bS
		call	__z80_op_F4
		ret
z80_CC		label	near			; CALL Z,nn
;		callcc	_bZ
		call	__z80_op_CC
		ret
z80_DC		label	near			; CALL C,nn
;		callcc	_bC
		call	__z80_op_DC
		ret
z80_EC		label	near			; CALL PE,nn
;		callcc	_bP
		call	__z80_op_EC
		ret
z80_FC		label	near			; CALL M,nn
;		callcc	_bS
		call	__z80_op_FC
		ret

z80_CD		label	near			; CALL nn
;		_FetchW
;pre_call:	mov	si,ax
;		mov	bx,bp
;		_PushW
;		mov	bp,si
;		mov	_cpu._PC,bp
;		mov	DWORD PTR _cpu._T,18
;		ret
		call	__z80_op_CD
		ret
;------------------------------------------------------------------------------
;		POP dd/PUSH dd
;------------------------------------------------------------------------------
;pop_dd		macro	dd
;		_PopW
;		mov	_cpu.&dd,ax
;		mov	DWORD PTR _cpu._T,12
;		ret
;		endm

z80_C1		label	near			; POP BC
;		pop_dd	_BC
		call	__z80_op_C1
		ret
z80_D1		label	near			; POP DE
;		pop_dd	_DE
		call	__z80_op_D1
		ret
z80_E1		label	near			; POP HL
;		pop_dd	_HL
		call	__z80_op_E1
		ret
z80_F1		label	near			; POP AF
;		pop_dd	_AF
		call	__z80_op_F1
		ret

;push_dd		macro	dd
;		mov	bx,_cpu.&dd
;		_PushW
;		mov	DWORD PTR _cpu._T,11
;		ret
;		endm

z80_C5		label	near			; PUSH BC
;		push_dd	_BC
		call	__z80_op_C5
		ret
z80_D5		label	near			; PUSH DE
;		push_dd	_DE
		call	__z80_op_D5
		ret
z80_E5		label	near			; PUSH HL
;		push_dd	_HL
		call	__z80_op_E5
		ret
z80_F5		label	near			; PUSH AF
;		push_dd	_AF
		call	__z80_op_F5
		ret
;------------------------------------------------------------------------------
;		math
;------------------------------------------------------------------------------
z80_C6		label	near			; ADD A,n
;		mov	DWORD PTR _cpu._T,8
;		_FetchB
;		add	_cpu._A,al
;		pushf
;		_addf
		call	__z80_op_C6
		ret
z80_D6		label	near			; SUB A,n
;		mov	DWORD PTR _cpu._T,8
;		_FetchB
;		sub	_cpu._A,al
;		pushf
;		_subf
		call	__z80_op_D6
		ret
z80_E6		label	near			; AND A,n
;		mov	DWORD PTR _cpu._T,8
;		_FetchB
;		and	_cpu._A,al
;		pushf
;		_andf
		call	__z80_op_E6
		ret
z80_F6		label	near			; OR A,n
;		mov	DWORD PTR _cpu._T,8
;		_FetchB
;		or	_cpu._A,al
;		pushf
;		_orf
		call	__z80_op_F6
		ret
z80_CE		label	near			; ADC A,n
;		mov	DWORD PTR _cpu._T,8
;		_FetchB
;		bt	DWORD PTR _cpu._F,_CY
;		adc	_cpu._A,al
;		pushf
;		_addf
		call	__z80_op_CE
		ret
z80_DE		label	near			; SBC A,n
;		mov	DWORD PTR _cpu._T,8
;		_FetchB
;		bt	DWORD PTR _cpu._F,_CY
;		sbb	_cpu._A,al
;		pushf
;		_subf
		call	__z80_op_DE
		ret
z80_EE		label	near			; XOR A,n
;		mov	DWORD PTR _cpu._T,8
;		_FetchB
;		xor	_cpu._A,al
;		pushf
;		_orf
		call	__z80_op_EE
		ret
z80_FE		label	near			; CP A,n
;		mov	DWORD PTR _cpu._T,8
;		_FetchB
;		cmp	_cpu._A,al
;		pushf
;		_subf
		call	__z80_op_FE
		ret
;------------------------------------------------------------------------------
;		RST xx
;------------------------------------------------------------------------------
z80_C7		label	near			; RST 00H
;		mov	si,0000h
;		jmp	SHORT @f
		call	__z80_op_C7
		ret
z80_D7		label	near			; RST 10H
;		mov	si,0010h
;		jmp	SHORT @f
		call	__z80_op_D7
		ret
z80_E7		label	near			; RST 20H
;		mov	si,0020h
;		jmp	SHORT @f
		call	__z80_op_E7
		ret
z80_F7		label	near			; RST 30H
;		mov	si,0030h
;		jmp	SHORT @f
		call	__z80_op_F7
		ret
z80_CF		label	near			; RST 08H
;		mov	si,0008h
;		jmp	SHORT @f
		call	__z80_op_CF
		ret
z80_DF		label	near			; RST 18H
;		mov	si,0018h
;		jmp	SHORT @f
		call	__z80_op_DF
		ret
z80_EF		label	near			; RST 28H
;		mov	si,0028h
;		jmp	SHORT @f
		call	__z80_op_EF
		ret
z80_FF		label	near			; RST 38H
;		mov	si,0038h
;@@:		mov	bx,bp
;		_PushW
;		mov	bp,si
;		mov	_cpu._PC,bp
;		mov	DWORD PTR _cpu._T,12
;		ret
		call	__z80_op_FF
		ret
;------------------------------------------------------------------------------
;		misc
;------------------------------------------------------------------------------
z80_F9		label	near			; LD SP,HL
;		mov	DWORD PTR _cpu._T,7
;		mov	ax,_cpu._HL
;		mov	_cpu._SP,ax
;		ret
		call	__z80_op_F9
		ret
z80_E3		label	near			; EX (SP),HL
;		mov	DWORD PTR _cpu._T,20
;		mov	si,_cpu._SP
;		mov	ax,si
;		call	_mwread
;		xchg	ax,_cpu._HL
;		mov	bx,ax
;		mov	ax,si
;		call	_mwwrite
;		ret
		call	__z80_op_E3
		ret

;_exx		macro	s,d
;		mov	ax,_cpu.&s
;		xchg	ax,_cpu.&d
;		mov	_cpu.&s,ax
;		endm

z80_D9		label	near			; EXX
;		mov	DWORD PTR _cpu._T,5
;		_exx	_BC,_BC2
;		_exx	_DE,_DE2
;		_exx	_HL,_HL2
;		ret
		call	__z80_op_D9
		ret
z80_EB		label	near			; EX DE,HL
;		mov	DWORD PTR _cpu._T,5
;		_exx	_DE,_HL
;		ret
		call	__z80_op_EB
		ret

z80_F3		label	near			; DI
;		mov	DWORD PTR _cpu._T,5
;		mov	BYTE PTR _cpu._IFF1,0
;		mov	BYTE PTR _cpu._IFF2,0
;		ret
		call	__z80_op_F3
		ret
z80_FB		label	near			; EI
;		mov	DWORD PTR _cpu._T,5
;		mov	BYTE PTR _cpu._IFF1,1
;		mov	BYTE PTR _cpu._IFF2,1
;		ret
		call	__z80_op_FB
		ret
z80_D3		label	near			; OUT (n),A
;		mov	DWORD PTR _cpu._T,12
;		_FetchB
;		mov	bl,_cpu._A
;		call	_iowrite
;		ret
		call	__z80_op_D3
		ret
z80_DB		label	near			; IN A,(n)
;		mov	DWORD PTR _cpu._T,12
;		_FetchB
;		call	_ioread
;		mov	_cpu._A,al
;		ret
		call	__z80_op_DB
		ret
_8080B		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
