;==============================================================================
;
;	Z80 Emulator Ver 2.00
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 4.0
;	last modified  Jun,23,1996.
;
;==============================================================================
include		z80em.mac
include		flag.mac
public		z80_CB
extrn		__z80_op_CB:near
;		irpc	h,<0123456789ABCDEF>
;		irpc	l,<0123456789ABCDEF>
;extrn		__z80_op_CB_&h&&l:near
;		endm
;		endm
;==============================================================================
;_DATA		segment
;		even
;_bitop_glue	label	dword
;		irpc	h,<0123456789ABCDEF>
;		irpc	l,<0123456789ABCDEF>
;		dd	OFFSET FLAT:__z80_op_CB_&h&&l
;		endm
;		endm
;_DATA		ends
;==============================================================================
_TEXT		segment
;		assume	CS: _TEXT
;------------------------------------------------------------------------------
;		void	z80_CB (void)
;------------------------------------------------------------------------------
z80_CB		proc	near
;		_FetchB
;		movzx	ebx,al
;		jmp	DWORD PTR _bitop_glue[ebx*4]
		call __z80_op_CB
		ret
;------------------------------------------------------------------------------
;		rotate routines
;------------------------------------------------------------------------------
;_rlc		macro	r
;		mov	DWORD PTR _cpu._T,10
;		mov	al,_cpu.&r
;		rol	al,1
;		mov	_cpu.&r,al
;		pushf
;		_rxxf
;		endm
;
;CB_00		label	near			; RLC B
;		_rlc	_B
;CB_01		label	near			; RLC C
;		_rlc	_C
;CB_02		label	near			; RLC D
;		_rlc	_D
;CB_03		label	near			; RLC E
;		_rlc	_E
;CB_04		label	near			; RLC H
;		_rlc	_H
;CB_05		label	near			; RLC L
;		_rlc	_L
;CB_07		label	near			; RLC A
;		_rlc	_A
;CB_06		label	near			; RLC (HL)
;		mov	DWORD PTR _cpu._T,17
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		rol	al,1
;		mov	di,ax
;		pushf
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		mov	ax,di
;		_rxxf
;
;_rrc		macro	r
;		mov	DWORD PTR _cpu._T,10
;		mov	al,_cpu.&r
;		ror	al,1
;		mov	_cpu.&r,al
;		pushf
;		_rxxf
;		endm
;
;CB_08		label	near			; RRC B
;		_rrc	_B
;CB_09		label	near			; RRC C
;		_rrc	_C
;CB_0A		label	near			; RRC D
;		_rrc	_D
;CB_0B		label	near			; RRC E
;		_rrc	_E
;CB_0C		label	near			; RRC H
;		_rrc	_H
;CB_0D		label	near			; RRC L
;		_rrc	_L
;CB_0F		label	near			; RRC A
;		_rrc	_A
;CB_0E		label	near			; RRC (HL)
;		mov	DWORD PTR _cpu._T,17
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		ror	al,1
;		mov	di,ax
;		pushf
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		mov	ax,di
;		_rxxf
;
;_rl		macro	r
;		mov	DWORD PTR _cpu._T,10
;		mov	al,_cpu.&r
;		bt	DWORD PTR _cpu._F,_CY
;		rcl	al,1
;		mov	_cpu.&r,al
;		pushf
;		_rxxf
;		endm
;
;CB_10		label	near			; RL B
;		_rl	_B
;CB_11		label	near			; RL C
;		_rl	_C
;CB_12		label	near			; RL D
;		_rl	_D
;CB_13		label	near			; RL E
;		_rl	_E
;CB_14		label	near			; RL H
;		_rl	_H
;CB_15		label	near			; RL L
;		_rl	_L
;CB_17		label	near			; RL A
;		_rl	_A
;CB_16		label	near			; RL (HL)
;		mov	DWORD PTR _cpu._T,17
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		bt	DWORD PTR _cpu._F,_CY
;		rcl	al,1
;		mov	di,ax
;		pushf
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		mov	ax,di
;		_rxxf
;
;_rr		macro	r
;		mov	DWORD PTR _cpu._T,10
;		mov	al,_cpu.&r
;		bt	DWORD PTR _cpu._F,_CY
;		rcr	al,1
;		mov	_cpu.&r,al
;		pushf
;		_rxxf
;		endm
;
;CB_18		label	near			; RR B
;		_rr	_B
;CB_19		label	near			; RR C
;		_rr	_C
;CB_1A		label	near			; RR D
;		_rr	_D
;CB_1B		label	near			; RR E
;		_rr	_E
;CB_1C		label	near			; RR H
;		_rr	_H
;CB_1D		label	near			; RR L
;		_rr	_L
;CB_1F		label	near			; RR A
;		_rr	_A
;CB_1E		label	near			; RR (HL)
;		mov	DWORD PTR _cpu._T,17
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		bt	DWORD PTR _cpu._F,_CY
;		rcr	al,1
;		mov	di,ax
;		pushf
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		mov	ax,di
;		_rxxf
;------------------------------------------------------------------------------
;		shift routines
;------------------------------------------------------------------------------
;_sla		macro	r
;		mov	DWORD PTR _cpu._T,10
;		sal	_cpu.&r,1
;		pushf
;		_shxf
;		endm
;
;CB_20		label	near			; SLA B
;		_sla	_B
;CB_21		label	near			; SLA C
;		_sla	_C
;CB_22		label	near			; SLA D
;		_sla	_D
;CB_23		label	near			; SLA E
;		_sla	_E
;CB_24		label	near			; SLA H
;		_sla	_H
;CB_25		label	near			; SLA L
;		_sla	_L
;CB_27		label	near			; SLA A
;		_sla	_A
;CB_26		label	near			; SLA (HL)
;		mov	DWORD PTR _cpu._T,17
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		sal	al,1
;		pushf
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		_shxf
;
;_sra		macro	r
;		mov	DWORD PTR _cpu._T,10
;		sar	_cpu.&r,1
;		pushf
;		_shxf
;		endm
;
;CB_28		label	near			; SRA B
;		_sra	_B
;CB_29		label	near			; SRA C
;		_sra	_C
;CB_2A		label	near			; SRA D
;		_sra	_D
;CB_2B		label	near			; SRA E
;		_sra	_E
;CB_2C		label	near			; SRA H
;		_sra	_H
;CB_2D		label	near			; SRA L
;		_sra	_L
;CB_2F		label	near			; SRA A
;		_sra	_A
;CB_2E		label	near			; SRA (HL)
;		mov	DWORD PTR _cpu._T,17
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		sar	al,1
;		pushf
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		_shxf
;
;_srl		macro	r
;		mov	DWORD PTR _cpu._T,10
;		shr	_cpu.&r,1
;		pushf
;		_shxf
;		endm
;
;CB_38		label	near			; SRL B
;		_srl	_B
;CB_39		label	near			; SRL C
;		_srl	_C
;CB_3A		label	near			; SRL D
;		_srl	_D
;CB_3B		label	near			; SRL E
;		_srl	_E
;CB_3C		label	near			; SRL H
;		_srl	_H
;CB_3D		label	near			; SRL L
;		_srl	_L
;CB_3F		label	near			; SRL A
;		_srl	_A
;CB_3E		label	near			; SRL (HL)
;		mov	DWORD PTR _cpu._T,17
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		shr	al,1
;		pushf
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		_shxf
;------------------------------------------------------------------------------
;		bit routines
;------------------------------------------------------------------------------
;_bit		macro	b,r
;		mov	DWORD PTR _cpu._T,10
;		bt	DWORD PTR _cpu.&r,b
;		pushf
;		_bitf
;		endm

;_bit_hl		macro	b
;		mov	DWORD PTR _cpu._T,14
;		mov	ax,_cpu._HL
;		call	_mbread
;		bt	ax,b
;		pushf
;		_bitf
;		endm

;CB_40		label	near			; BIT 0,B
;		_bit	0,_B
;CB_41		label	near			; BIT 0,C
;		_bit	0,_C
;CB_42		label	near			; BIT 0,D
;		_bit	0,_D
;CB_43		label	near			; BIT 0,E
;		_bit	0,_E
;CB_44		label	near			; BIT 0,H
;		_bit	0,_H
;CB_45		label	near			; BIT 0,L
;		_bit	0,_L
;CB_46		label	near			; BIT 0,(HL)
;		_bit_hl	0
;CB_47		label	near			; BIT 0,A
;		_bit	0,_A

;CB_48		label	near			; BIT 1,B
;		_bit	1,_B
;CB_49		label	near			; BIT 1,C
;		_bit	1,_C
;CB_4A		label	near			; BIT 1,D
;		_bit	1,_D
;CB_4B		label	near			; BIT 1,E
;		_bit	1,_E
;CB_4C		label	near			; BIT 1,H
;		_bit	1,_H
;CB_4D		label	near			; BIT 1,L
;		_bit	1,_L
;CB_4E		label	near			; BIT 1,(HL)
;		_bit_hl	1
;CB_4F		label	near			; BIT 1,A
;		_bit	1,_A

;CB_50		label	near			; BIT 2,B
;		_bit	2,_B
;CB_51		label	near			; BIT 2,C
;		_bit	2,_C
;CB_52		label	near			; BIT 2,D
;		_bit	2,_D
;CB_53		label	near			; BIT 2,E
;		_bit	2,_E
;CB_54		label	near			; BIT 2,H
;		_bit	2,_H
;CB_55		label	near			; BIT 2,L
;		_bit	2,_L
;CB_56		label	near			; BIT 2,(HL)
;		_bit_hl	2
;CB_57		label	near			; BIT 2,A
;		_bit	2,_A

;CB_58		label	near			; BIT 3,B
;		_bit	3,_B
;CB_59		label	near			; BIT 3,C
;		_bit	3,_C
;CB_5A		label	near			; BIT 3,D
;		_bit	3,_D
;CB_5B		label	near			; BIT 3,E
;		_bit	3,_E
;CB_5C		label	near			; BIT 3,H
;		_bit	3,_H
;CB_5D		label	near			; BIT 3,L
;		_bit	3,_L
;CB_5E		label	near			; BIT 3,(HL)
;		_bit_hl	3
;CB_5F		label	near			; BIT 3,A
;		_bit	3,_A

;CB_60		label	near			; BIT 4,B
;		_bit	4,_B
;CB_61		label	near			; BIT 4,C
;		_bit	4,_C
;CB_62		label	near			; BIT 4,D
;		_bit	4,_D
;CB_63		label	near			; BIT 4,E
;		_bit	4,_E
;CB_64		label	near			; BIT 4,H
;		_bit	4,_H
;CB_65		label	near			; BIT 4,L
;		_bit	4,_L
;CB_66		label	near			; BIT 4,(HL)
;		_bit_hl	4
;CB_67		label	near			; BIT 4,A
;		_bit	4,_A

;CB_68		label	near			; BIT 5,B
;		_bit	5,_B
;CB_69		label	near			; BIT 5,C
;		_bit	5,_C
;CB_6A		label	near			; BIT 5,D
;		_bit	5,_D
;CB_6B		label	near			; BIT 5,E
;		_bit	5,_E
;CB_6C		label	near			; BIT 5,H
;		_bit	5,_H
;CB_6D		label	near			; BIT 5,L
;		_bit	5,_L
;CB_6E		label	near			; BIT 5,(HL)
;		_bit_hl	5
;CB_6F		label	near			; BIT 5,A
;		_bit	5,_A

;CB_70		label	near			; BIT 6,B
;		_bit	6,_B
;CB_71		label	near			; BIT 6,C
;		_bit	6,_C
;CB_72		label	near			; BIT 6,D
;		_bit	6,_D
;CB_73		label	near			; BIT 6,E
;		_bit	6,_E
;CB_74		label	near			; BIT 6,H
;		_bit	6,_H
;CB_75		label	near			; BIT 6,L
;		_bit	6,_L
;CB_76		label	near			; BIT 6,(HL)
;		_bit_hl	6
;CB_77		label	near			; BIT 6,A
;		_bit	6,_A

;CB_78		label	near			; BIT 7,B
;		_bit	7,_B
;CB_79		label	near			; BIT 7,C
;		_bit	7,_C
;CB_7A		label	near			; BIT 7,D
;		_bit	7,_D
;CB_7B		label	near			; BIT 7,E
;		_bit	7,_E
;CB_7C		label	near			; BIT 7,H
;		_bit	7,_H
;CB_7D		label	near			; BIT 7,L
;		_bit	7,_L
;CB_7E		label	near			; BIT 7,(HL)
;		_bit_hl	7
;CB_7F		label	near			; BIT 7,A
;		_bit	7,_A
;------------------------------------------------------------------------------
;		reset routines
;------------------------------------------------------------------------------
;_res		macro	b,r
;		mov	DWORD PTR _cpu._T,10
;		btr	DWORD PTR _cpu.&r,b
;		ret
;		endm

;_res_hl		macro	b
;		mov	DWORD PTR _cpu._T,17
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		btr	ax,b
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		ret
;		endm

;CB_80		label	near			; RES 0,B
;		_res	0,_B
;CB_81		label	near			; RES 0,C
;		_res	0,_C
;CB_82		label	near			; RES 0,D
;		_res	0,_D
;CB_83		label	near			; RES 0,E
;		_res	0,_E
;CB_84		label	near			; RES 0,H
;		_res	0,_H
;CB_85		label	near			; RES 0,L
;		_res	0,_L
;CB_86		label	near			; RES 0,(HL)
;		_res_hl	0
;CB_87		label	near			; RES 0,A
;		_res	0,_A

;CB_88		label	near			; RES 1,B
;		_res	1,_B
;CB_89		label	near			; RES 1,C
;		_res	1,_C
;CB_8A		label	near			; RES 1,D
;		_res	1,_D
;CB_8B		label	near			; RES 1,E
;		_res	1,_E
;CB_8C		label	near			; RES 1,H
;		_res	1,_H
;CB_8D		label	near			; RES 1,L
;		_res	1,_L
;CB_8E		label	near			; RES 1,(HL)
;		_res_hl	1
;CB_8F		label	near			; RES 1,A
;		_res	1,_A

;CB_90		label	near			; RES 2,B
;		_res	2,_B
;CB_91		label	near			; RES 2,C
;		_res	2,_C
;CB_92		label	near			; RES 2,D
;		_res	2,_D
;CB_93		label	near			; RES 2,E
;		_res	2,_E
;CB_94		label	near			; RES 2,H
;		_res	2,_H
;CB_95		label	near			; RES 2,L
;		_res	2,_L
;CB_96		label	near			; RES 2,(HL)
;		_res_hl	2
;CB_97		label	near			; RES 2,A
;		_res	2,_A

;CB_98		label	near			; RES 3,B
;		_res	3,_B
;CB_99		label	near			; RES 3,C
;		_res	3,_C
;CB_9A		label	near			; RES 3,D
;		_res	3,_D
;CB_9B		label	near			; RES 3,E
;		_res	3,_E
;CB_9C		label	near			; RES 3,H
;		_res	3,_H
;CB_9D		label	near			; RES 3,L
;		_res	3,_L
;CB_9E		label	near			; RES 3,(HL)
;		_res_hl	3
;CB_9F		label	near			; RES 3,A
;		_res	3,_A

;CB_A0		label	near			; RES 4,B
;		_res	4,_B
;CB_A1		label	near			; RES 4,C
;		_res	4,_C
;CB_A2		label	near			; RES 4,D
;		_res	4,_D
;CB_A3		label	near			; RES 4,E
;		_res	4,_E
;CB_A4		label	near			; RES 4,H
;		_res	4,_H
;CB_A5		label	near			; RES 4,L
;		_res	4,_L
;CB_A6		label	near			; RES 4,(HL)
;		_res_hl	4
;CB_A7		label	near			; RES 4,A
;		_res	4,_A

;CB_A8		label	near			; RES 5,B
;		_res	5,_B
;CB_A9		label	near			; RES 5,C
;		_res	5,_C
;CB_AA		label	near			; RES 5,D
;		_res	5,_D
;CB_AB		label	near			; RES 5,E
;		_res	5,_E
;CB_AC		label	near			; RES 5,H
;		_res	5,_H
;CB_AD		label	near			; RES 5,L
;		_res	5,_L
;CB_AE		label	near			; RES 5,(HL)
;		_res_hl	5
;CB_AF		label	near			; RES 5,A
;		_res	5,_A

;CB_B0		label	near			; RES 6,B
;		_res	6,_B
;CB_B1		label	near			; RES 6,C
;		_res	6,_C
;CB_B2		label	near			; RES 6,D
;		_res	6,_D
;CB_B3		label	near			; RES 6,E
;		_res	6,_E
;CB_B4		label	near			; RES 6,H
;		_res	6,_H
;CB_B5		label	near			; RES 6,L
;		_res	6,_L
;CB_B6		label	near			; RES 6,(HL)
;		_res_hl	6
;CB_B7		label	near			; RES 6,A
;		_res	6,_A

;CB_B8		label	near			; RES 7,B
;		_res	7,_B
;CB_B9		label	near			; RES 7,C
;		_res	7,_C
;CB_BA		label	near			; RES 7,D
;		_res	7,_D
;CB_BB		label	near			; RES 7,E
;		_res	7,_E
;CB_BC		label	near			; RES 7,H
;		_res	7,_H
;CB_BD		label	near			; RES 7,L
;		_res	7,_L
;CB_BE		label	near			; RES 7,(HL)
;		_res_hl	7
;CB_BF		label	near			; RES 7,A
;		_res	7,_A
;------------------------------------------------------------------------------
;		set routines
;------------------------------------------------------------------------------
;_set		macro	b,r
;		mov	DWORD PTR _cpu._T,10
;		bts	DWORD PTR _cpu.&r,b
;		ret
;		endm
;
;_set_hl		macro	b
;		mov	DWORD PTR _cpu._T,17
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		bts	ax,b
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		ret
;		endm

;CB_C0		label	near			; SET 0,B
;		_set	0,_B
;CB_C1		label	near			; SET 0,C
;		_set	0,_C
;CB_C2		label	near			; SET 0,D
;		_set	0,_D
;CB_C3		label	near			; SET 0,E
;		_set	0,_E
;CB_C4		label	near			; SET 0,H
;		_set	0,_H
;CB_C5		label	near			; SET 0,L
;		_set	0,_L
;CB_C6		label	near			; SET 0,(HL)
;		_set_hl	0
;CB_C7		label	near			; SET 0,A
;		_set	0,_A

;CB_C8		label	near			; SET 1,B
;		_set	1,_B
;CB_C9		label	near			; SET 1,C
;		_set	1,_C
;CB_CA		label	near			; SET 1,D
;		_set	1,_D
;CB_CB		label	near			; SET 1,E
;		_set	1,_E
;CB_CC		label	near			; SET 1,H
;		_set	1,_H
;CB_CD		label	near			; SET 1,L
;		_set	1,_L
;CB_CE		label	near			; SET 1,(HL)
;		_set_hl	1
;CB_CF		label	near			; SET 1,A
;		_set	1,_A

;CB_D0		label	near			; SET 2,B
;		_set	2,_B
;CB_D1		label	near			; SET 2,C
;		_set	2,_C
;CB_D2		label	near			; SET 2,D
;		_set	2,_D
;CB_D3		label	near			; SET 2,E
;		_set	2,_E
;CB_D4		label	near			; SET 2,H
;		_set	2,_H
;CB_D5		label	near			; SET 2,L
;		_set	2,_L
;CB_D6		label	near			; SET 2,(HL)
;		_set_hl	2
;CB_D7		label	near			; SET 2,A
;		_set	2,_A

;CB_D8		label	near			; SET 3,B
;		_set	3,_B
;CB_D9		label	near			; SET 3,C
;		_set	3,_C
;CB_DA		label	near			; SET 3,D
;		_set	3,_D
;CB_DB		label	near			; SET 3,E
;		_set	3,_E
;CB_DC		label	near			; SET 3,H
;		_set	3,_H
;CB_DD		label	near			; SET 3,L
;		_set	3,_L
;CB_DE		label	near			; SET 3,(HL)
;		_set_hl	3
;CB_DF		label	near			; SET 3,A
;		_set	3,_A

;CB_E0		label	near			; SET 4,B
;		_set	4,_B
;CB_E1		label	near			; SET 4,C
;		_set	4,_C
;CB_E2		label	near			; SET 4,D
;		_set	4,_D
;CB_E3		label	near			; SET 4,E
;		_set	4,_E
;CB_E4		label	near			; SET 4,H
;		_set	4,_H
;CB_E5		label	near			; SET 4,L
;		_set	4,_L
;CB_E6		label	near			; SET 4,(HL)
;		_set_hl	4
;CB_E7		label	near			; SET 4,A
;		_set	4,_A

;CB_E8		label	near			; SET 5,B
;		_set	5,_B
;CB_E9		label	near			; SET 5,C
;		_set	5,_C
;CB_EA		label	near			; SET 5,D
;		_set	5,_D
;CB_EB		label	near			; SET 5,E
;		_set	5,_E
;CB_EC		label	near			; SET 5,H
;		_set	5,_H
;CB_ED		label	near			; SET 5,L
;		_set	5,_L
;CB_EE		label	near			; SET 5,(HL)
;		_set_hl	5
;CB_EF		label	near			; SET 5,A
;		_set	5,_A

;CB_F0		label	near			; SET 6,B
;		_set	6,_B
;CB_F1		label	near			; SET 6,C
;		_set	6,_C
;CB_F2		label	near			; SET 6,D
;		_set	6,_D
;CB_F3		label	near			; SET 6,E
;		_set	6,_E
;CB_F4		label	near			; SET 6,H
;		_set	6,_H
;CB_F5		label	near			; SET 6,L
;		_set	6,_L
;CB_F6		label	near			; SET 6,(HL)
;		_set_hl	6
;CB_F7		label	near			; SET 6,A
;		_set	6,_A

;CB_F8		label	near			; SET 7,B
;		_set	7,_B
;CB_F9		label	near			; SET 7,C
;		_set	7,_C
;CB_FA		label	near			; SET 7,D
;		_set	7,_D
;CB_FB		label	near			; SET 7,E
;		_set	7,_E
;CB_FC		label	near			; SET 7,H
;		_set	7,_H
;CB_FD		label	near			; SET 7,L
;		_set	7,_L
;CB_FE		label	near			; SET 7,(HL)
;		_set_hl	7
;CB_FF		label	near			; SET 7,A
;		_set	7,_A
;------------------------------------------------------------------------------
;		illegal instructions
;------------------------------------------------------------------------------
;		irpc	l,<01234567>
;CB_3&l		label	near
;		endm
;		mov	DWORD PTR _cpu._T,5
;		mov	BYTE PTR _z80_signal,_EXITBIT
;		mov	BYTE PTR _cpu._HALT,_HALTIL
;		ret
z80_CB		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
