//
//		IICCJ Class Library Ver 1.00
//		iiccj a
//
//		敪F  LFȂ  nrF95/NT  FC++
//		-----------------------------------------------
//		  	F	XbhNX
//		NXF	icj_thread
//		  I	F	
//		File敪F	NX(.cpp)
//		쐬	F	{ mu
//
//		Rev		t			ύX_
//		-----	----------	----------------------------------------------
//		1.0.0	1998.03.21	
//
#include "icj_thread.h"
///////////////////////////////////////////////////////////////////////////////
//	NX֐
///////////////////////////////////////////////////////////////////////////////
DWORD WINAPI
icj_thread::proxy_enter (LPVOID param)
{
	::InterlockedExchange ((LPLONG) &((icj_thread *) param)->m_thrd_run, 1);
	((icj_thread *) param)->enter();
	::InterlockedExchange ((LPLONG) &((icj_thread *) param)->m_thrd_run, 0);
	((icj_thread *) param)->leave();
	::ExitThread (0);
	return  0;	// dummy
}

///////////////////////////////////////////////////////////////////////////////
//	XbhJn^I
///////////////////////////////////////////////////////////////////////////////
BOOL
icj_thread::start(BOOL fsuspend)
{
	DWORD  susp = fsuspend ? CREATE_SUSPENDED : 0;

	m_thread = ::CreateThread(NULL, 0, proxy_enter,
							  (LPVOID) (icj_thread *) this, susp, &m_threadid);
	return  !m_thread ? FALSE : TRUE;
}

void
icj_thread::kill()
{
	DWORD	dr;

	if (m_thread == NULL)
		return;
	dr = ::WaitForSingleObject(m_thread, 5000);
	switch (dr)
	{
	case  WAIT_OBJECT_0:
		break;
	case  WAIT_TIMEOUT:
	default:
		::TerminateThread(m_thread, 0);
		::InterlockedExchange((LPLONG) &m_thrd_run, 0);
		break;
	}
	::CloseHandle(m_thread);
	m_thread   = NULL;
	m_threadid = 0;
}

void
icj_thread::leave()
{
	//	XbhIO proxy Ăяonhj֐
	::CloseHandle(m_thread);
	m_thread   = NULL;
	m_threadid = 0;
}
///////////////////////////////////////////////////////////////////////////////
//	Xbh[`{
///////////////////////////////////////////////////////////////////////////////
void
icj_thread::enter()
{
	//	I[o[Ch
}
///////////////////////////////////////////////////////////////////////////////
//	Xbh
///////////////////////////////////////////////////////////////////////////////
DWORD
icj_thread::suspend()
{
	return  ::SuspendThread(m_thread);
}

DWORD
icj_thread::resume()
{
	return  ::ResumeThread(m_thread);
}

///////////////////////////////////////////////////////////////////////////////
//	XbhD揇
///////////////////////////////////////////////////////////////////////////////
int
icj_thread::getPriority()
{
	return  ::GetThreadPriority(m_thread);
}

BOOL
icj_thread::setPriority(int priority)
{
	return  ::SetThreadPriority(m_thread, priority);
}
